<script lang="ts">
    import Outages from "./Outages.svelte"

    import type downtimeType from "../../types/downtime"
    import { UPDOWN_KEY } from "../../config"
    import sites from "../../sites"

    let days = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30]
    let outages

    const today = new Date()
    const start = new Date(today.getTime() - 1000 * 60 * 60 * 24 * days.length) // 30 Days

    const isFinshed = date => {
        const time = new Date(date).getTime()

        if(time < start.getTime())
            return true
        else
            return false
    }
    const getData = async (startData: Array<downtimeType> = [], page = 1) => {
        let data: Array<downtimeType> = startData
        let finished = false

        const response = await (await fetch(`https://updown.io/api/checks/${token}/downtimes?api-key=${UPDOWN_KEY}&page=${page}`)).json() as Array<downtimeType>

        response.forEach(entry => {
            if(!isFinshed(entry.started_at)) {
                // @ts-ignore
                data.push(entry)
            } else
                finished = true
        })

        if(response.length == 0) outages = []
        else outages = finished ? data : getData(data, page + 1)
    }

    const findOutages = (ofset: number) => {
        let down = []
        
        outages.forEach(entry => {
            const date = new Date(entry.started_at)

            if(start.getTime() + 1000 * 60 * 60 * 24 * ofset < date.getTime() && start.getTime() + 1000 * 60 * 60 * 24 * (ofset + 1) >= date.getTime()) down.push(entry)
        })

        return down
    }
    const isOk = (ofset) => findOutages(ofset).length == 0

    export let token: string
    let active: null | number
</script>

<div class="container">
    <div>
        <span>
            Letzter Monat
        </span>
        <h3>{sites && sites[token] ? sites[token][0] : "?"}</h3>
        <span>
            Heute
        </span>
    </div>
    <aside>
        {#await getData()}
            <h1>Lade...</h1>
        {:then}
            {#each days as day}
                <figure on:click={() => active = day} class:ok={isOk(day)} class:active={active == day}></figure>
            {/each}
        {:catch error}
            <code>
                {error}
            </code>
        {/await}
    </aside>
    {#if active != null}
        <Outages outages={findOutages(active).reverse()}></Outages>
    {/if}
</div>

<style>
    div.container {
        display: block;
        margin: auto;
        margin-top: 25px;

        width: 90vw;
        max-width: calc(31 * 14px);
    }
    div.container div {
        display: grid;
        grid-template-columns: 40px 1fr 40px;
        align-items: baseline;
    }
    div.container div span {
        font-size: 10px;
        color: var(--gray);
    }
    div.container div span:first-child {
        position: relative;
        top: -13px;
    }
    div.container div span:last-child {
        text-align: right;
    }

    h3 {
        text-align: center;
        margin-bottom: 5px;

        font-weight: 500;
        font-size: 32px;
    }

    aside {
        display: flex;
        margin: 0px auto;

        height: 75px;
        align-items: center;
    }
    figure {
        height: 50px;
        width: 10px;

        border-radius: 3px;
        cursor: pointer;

        display: block;
        margin: 0px 2px;

        background-color: red;
        transition: height 100ms, width 100ms;
    }
    figure.ok {
        background-color: var(--green);
    }
    figure.active, figure:hover {
        height: 75px;
        width: 13px;
    }
</style>